build.sh 10 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177178179180181182183184185186187188189190191192193194195196197198199200201202203204205206207208209210211212213214215216217218219220221222223224225226227228229230231232233234235236237238239240241242243244245246247248249250251252253254255256257258259260261262263264265266267268269270271272273274275276277
  1. #!/bin/bash
  2. # (c) 2014-2018 Freifunk Hochstift <kontakt@hochstift.freifunk.net>
  3. #
  4. # This script builds the firmware by the environment variables given, the
  5. # first two being mandatory:
  6. #
  7. # BASE = Gluon Version (branch, tag or commit, i.e. v2014.4)
  8. # BRANCH = Firmware Branch (stable/testing/experimental)
  9. # VERSION = the version tag (can only be empty if BRANCH=experimental)
  10. #
  11. # optional:
  12. # AUTOUPDATER = force Autoupdater Branch (stable/testing/experimental/off)
  13. # BROKEN = 0 (default) or 1, build the untested hardware model firmwares, too
  14. # BUILD_TS = build timestamp (format: %Y-%m-%d %H:%M:%S)
  15. # CLEAN = 'dirclean' to perform "make dirclean" before build or 'clean' to perform "make clean" (default: 'none')
  16. # DEVICES = build some specific devices and not the entire target
  17. # KEY_DIR = specify directory for gluon-opkg-key
  18. # MAKEJOBS = number of compiler processes running in parallel (default: number of CPUs/Cores)
  19. # PRIORITY = determines the number of day a rollout phase should last at most
  20. # PUBLISH = 0 (default) or 1, publish firmware at the end
  21. # SITE_ID = specific site repository commit-id (leave blank to use HEAD)
  22. # TARGETS = a space separated list of target platforms (if unset, all platforms will be build)
  23. # VERBOSE = 0 (default) or 1, call the make commands with 'V=s' to see actual errors better
  24. # VERSIONS_DIR = specify directory for version files
  25. #
  26. ### includes
  27. . functions.sh
  28. ### static variables
  29. MY_DIR=$(dirname $0)
  30. MY_DIR=$(readlink -f "${MY_DIR}")
  31. DEFAULT_KEY_DIR="${MY_DIR}/opkg-keys"
  32. DEFAULT_VERSIONS_DIR="${MY_DIR}/versions"
  33. CODE_DIR="${MY_DIR}/src"
  34. GLUON_BUILD_DIR="${CODE_DIR}/lede"
  35. SITE_DIR="${CODE_DIR}/site"
  36. PATCH_DIR="${SITE_DIR}/patches"
  37. OUTPUT_DIR="${MY_DIR}/output"
  38. IMAGE_DIR="${CODE_DIR}/output/images"
  39. PACKAGES_DIR="${CODE_DIR}/output/packages"
  40. MANIFEST_DIR="${CODE_DIR}/output/images/sysupgrade"
  41. SITE_GEN_SCRIPT="${CODE_DIR}/packages/ffho/ffho/ffho-site-generate/scripts/gen-site-conf.lua"
  42. SRV_URL="firmware.in.ffho.net"
  43. SRV_USER="firmware"
  44. SRV_PATH="/srv/firmware"
  45. BUILD_INFO_FILENAME="build-info.txt"
  46. SITE_REPO_URL="https://git.ffho.net/freifunkhochstift/ffho-site.git"
  47. GLUON_REPO_URL="https://git.ffho.net/freifunkhochstift/gluon.git"
  48. LANG=C
  49. pushd ${MY_DIR} > /dev/null
  50. ### set reasonable defaults for unset environment variables
  51. [ -n "${AUTOUPDATER}" ] || AUTOUPDATER=${BRANCH}
  52. [ "${BROKEN}" -eq "1" ] && export BROKEN || unset BROKEN
  53. [ -n "${BUILD_TS}" ] || BUILD_TS=$(date +"%Y-%m-%d %H:%M:%S")
  54. [ -n "${CLEAN}" ] || CLEAN="none"
  55. if [ -n "${KEY_DIR}" ]; then
  56. KEY_DIR=$(readlink -f "${KEY_DIR}")
  57. [ -e "${KEY_DIR}" ] || abort "Can not find specified key directory: ${KEY_DIR}"
  58. else
  59. KEY_DIR="${DEFAULT_KEY_DIR}"
  60. fi
  61. [ -n "${MAKEJOBS}" ] || MAKEJOBS=$(grep -c "^processor" /proc/cpuinfo)
  62. [ -n "${PRIORITY}" ] || PRIORITY=0
  63. [ -n "${PUBLISH}" ] || PUBLISH=0
  64. [ -n "${VERBOSE}" ] || VERBOSE=0
  65. if [ -n "${VERSIONS_DIR}" ]; then
  66. VERSIONS_DIR=$(readlink -f "${VERSIONS_DIR}")
  67. else
  68. VERSIONS_DIR="${DEFAULT_VERSIONS_DIR}"
  69. fi
  70. MAKE_PARAM=""
  71. [ "${VERBOSE}" -eq "1" ] && MAKE_PARAM="${MAKE_PARAM} V=s"
  72. [ -n "${DEVICE}" ] && MAKE_PARAM="${MAKE_PARAM} DEVICE=${DEVICE}"
  73. ### ERROR handling
  74. [ -n "${BASE}" ] || abort "Please specify BASE environment variable (Gluon, i.e. 'v2014.3' or commit-id)."
  75. [ "${BASE}" == "HEAD" ] && abort "HEAD is not an allowed BASE-identifier. Either use a branch, a tagged commit or the commit-SHA itself."
  76. [ -n "${BRANCH}" ] || abort "Please specify BRANCH environment variable."
  77. [ -n "${VERSION}" -o "${BRANCH}" == "experimental" ] || abort "Please specify VERSION environment variable (not necessary for experimental branch)."
  78. [ "${BRANCH}" == "experimental" -o ! -r "${VERSIONS_DIR}/${VERSION}" ] || abort "There exists a version file for '${VERSION}' ... you are trying to do something really stupid, aren't you?"
  79. ### init VERSIONS_DIR if necessary
  80. if [ ! -d "${VERSIONS_DIR}" ]; then
  81. info "Versions directory does not exist yet - creating it ..."
  82. mkdir -p ${VERSIONS_DIR}
  83. [ "$?" -eq "0" ] || abort "Unable to create versions directory: ${VERSIONS_DIR}"
  84. fi
  85. ### init CODE_DIR if necessary
  86. if [ ! -d "${CODE_DIR}" ]; then
  87. info "Code directory does not exist yet - fetching Gluon ..."
  88. git clone "${GLUON_REPO_URL}" "${CODE_DIR}"
  89. [ "$?" -eq "0" ] || abort "Failed to fetch Gluon repository."
  90. fi
  91. ### init SITE_DIR if necessary
  92. if [ ! -d "${SITE_DIR}" ]; then
  93. info "Site repository does not exist, fetching it ..."
  94. git clone "${SITE_REPO_URL}" "${SITE_DIR}"
  95. [ "$?" -eq "0" ] || abort "Failed to fetch SITE repository."
  96. fi
  97. ### CHECKOUT GLUON
  98. progress "Checking out GLUON '${BASE}' ..."
  99. pushd ${CODE_DIR} > /dev/null
  100. # check if gluon got modified and bail out if necessary
  101. [ "$(git status --porcelain)" ] && abort "Local changes to gluon directory. Cowardly refusing to update repository." >&2
  102. git fetch
  103. git show-ref --verify --quiet refs/remotes/origin/${BASE}
  104. if [ "$?" -eq "0" ]; then
  105. git checkout -B build origin/${BASE}
  106. [ "$?" -eq "0" ] || abort "Failed to checkout gluon origin/${BASE}."
  107. else
  108. git checkout -q ${BASE}
  109. [ "$?" -eq "0" ] || abort "Failed to checkout gluon ${BASE}." >&2
  110. fi
  111. GLUON_COMMIT=$(git rev-list --max-count=1 HEAD)
  112. popd > /dev/null #${CODE_DIR}
  113. ### CHECKOUT SITE REPO
  114. progress "Checking out SITE REPO ..."
  115. pushd ${SITE_DIR} > /dev/null
  116. if [ $(git remote | wc -l) -ge "1" ]; then
  117. git fetch
  118. # TODO: check if site got modified locally and bail out if necessary
  119. if [ -z "${SITE_ID}" ]; then
  120. # no specific site given - get the most current one
  121. git checkout -q ${BRANCH}
  122. git branch -r | grep ${BRANCH} > /dev/null
  123. if [ "$?" -eq "0" ]; then
  124. git rebase
  125. [ "$?" -eq "0" ] || abort "Failed to get newest '${BRANCH}' in site repository, mimimi."
  126. fi
  127. else
  128. # fetch site repo updates
  129. git fetch || true
  130. # commit given - use this one
  131. git checkout -q ${SITE_ID}
  132. [ "$?" -eq "0" ] || abort "Failed to checkout requested site commit '${SITE_ID}', mimimi."
  133. fi
  134. fi
  135. SITE_COMMIT=$(git rev-list --max-count=1 HEAD)
  136. popd > /dev/null #${SITE_DIR}
  137. pushd ${CODE_DIR} > /dev/null
  138. ### DIRCLEAN
  139. if [ -d "${GLUON_BUILD_DIR}/" -a "${CLEAN}" == "dirclean" ]; then
  140. progress "Cleaning your build environment (make dirclean) ..."
  141. make dirclean
  142. fi
  143. ### PREPARE
  144. progress "Preparing the build environment (make update) ..."
  145. make update
  146. [ "$?" -eq "0" ] || abort "Failed to update the build environment, mimimi."
  147. ### set reasonable defaults for TARGETS and VERSION if unset
  148. if [ -z "${TARGETS}" ]; then
  149. TARGETS=$(make list-targets | sed ':a;N;$!ba;s/\n/ /g')
  150. info "building all targets: '${TARGETS}'"
  151. fi
  152. if [ -z "${VERSION}" ] ; then
  153. VERSION=$(make show-release)
  154. info "${BRANCH} firmware: using version tag '${VERSION}'"
  155. fi
  156. popd > /dev/null #${CODE_DIR}
  157. # we are now ready to produce the firmware images, so let's "save" our state
  158. build_info_path="${VERSIONS_DIR}/${VERSION}"
  159. progress "Saving build information to: ${build_info_path}"
  160. [ -n "${build_info_path}" -a -f "${build_info_path}" ] && rm -f ${build_info_path}
  161. mkdir -p $(dirname ${build_info_path})
  162. [ "$?" -eq "0" ] || abort "Unable to create output directory: $(dirname ${build_info_path})"
  163. touch $(dirname ${build_info_path})
  164. [ "$?" -eq "0" ] || abort "Cannot create build information file: ${build_info_path}"
  165. echo "VERSION=${VERSION}" >> ${build_info_path}
  166. echo "GLUON=${GLUON_COMMIT} # ${BASE}" >> ${build_info_path}
  167. echo "BRANCH=${BRANCH}" >> ${build_info_path}
  168. echo "SITE=${SITE_COMMIT} # ${VERSION}" >> ${build_info_path}
  169. echo "TARGETS='${TARGETS}'" >> ${build_info_path}
  170. echo "TS=${BUILD_TS}" >> ${build_info_path}
  171. ### restore opkg-keys
  172. if [ -e "${KEY_DIR}" ]; then
  173. info "build key already exists, restoring it."
  174. mkdir -p ${GLUON_BUILD_DIR}/
  175. [ "$?" -eq "0" ] || abort "Unable to create directory: ${GLUON_BUILD_DIR}/"
  176. cp -f ${KEY_DIR}/* ${GLUON_BUILD_DIR}/
  177. [ "$?" -eq "0" ] || abort "Unable to copy build key."
  178. fi
  179. ### create site.conf
  180. if [ -x "${SITE_GEN_SCRIPT}" ]; then
  181. progress "Generating defaut site.conf"
  182. eval GLUON_SITEDIR=${SITE_DIR} ${SITE_GEN_SCRIPT}
  183. fi
  184. ### BUILD FIRMWARE
  185. progress "Building the firmware - please stand by!"
  186. pushd ${CODE_DIR} > /dev/null
  187. export GLUON_RELEASE="${VERSION}"
  188. [ "${AUTOUPDATER}" != "off" ] && export GLUON_BRANCH="${AUTOUPDATER}"
  189. for target in ${TARGETS} ; do
  190. # configure build environment for our current target
  191. export GLUON_TARGET="${target}"
  192. # prepare build environment for our current target
  193. if [ "${CLEAN}" == "clean" ]; then
  194. progress "${target}: Preparing build environment. (make clean)"
  195. make clean
  196. [ "$?" -eq "0" ] || abort "${target}: Unable to clean environment."
  197. fi
  198. # now we can start building the images for the target platform
  199. progress "${target}: Building FFHO-flavoured Gluon firmware. You'd better go and fetch some c0ffee!"
  200. make -j ${MAKEJOBS} ${MAKE_PARAM}
  201. [ "$?" -eq "0" ] || abort "${target}: Unable to build firmware."
  202. done
  203. # generate manifest
  204. progress "Generating manifest ..."
  205. GLUON_PRIORITY=${PRIORITY} GLUON_BRANCH=${BRANCH} make manifest
  206. [ "$?" -eq "0" ] || abort "Failed to generate the manifest."
  207. popd > /dev/null #${CODE_DIR}
  208. if [ "${PUBLISH}" -eq "1" ]; then
  209. # copying firmware to the server
  210. if [ -d "${IMAGE_DIR}" ]; then
  211. progress "Copying firmware images ..."
  212. rsync -rlutzc --filter="+ */" --filter="+ *-${VERSION}-*" --filter="- *" -e ssh ${IMAGE_DIR}/ ${SRV_USER}@${SRV_URL}:${SRV_PATH}/${VERSION}
  213. [ "$?" -eq "0" ] || abort "Failed to copy firmware images."
  214. fi
  215. # copying packages to the server
  216. PKG_SUB_DIR=$(find ${PACKAGES_DIR}/ -maxdepth 1 -name *${VERSION})
  217. if [ -d "${PKG_SUB_DIR}" ]; then
  218. progress "Copying packages ..."
  219. rsync -rlutzc -e ssh ${PKG_SUB_DIR}/ ${SRV_USER}@${SRV_URL}:${SRV_PATH}/${VERSION}/packages
  220. [ "$?" -eq "0" ] || abort "Failed to copy packages."
  221. fi
  222. # copy manifest and the build info file
  223. progress "Copying manifest and build info file ..."
  224. pushd ${OUTPUT_DIR} > /dev/null
  225. git fetch
  226. git checkout -q signing
  227. git merge --ff-only origin/master
  228. mkdir -p "${OUTPUT_DIR}/${VERSION}/sysupgrade"
  229. cp -f "${MANIFEST_DIR}/${BRANCH}.manifest" "${OUTPUT_DIR}/${VERSION}/sysupgrade/"
  230. cp -f "${build_info_path}" "${OUTPUT_DIR}/${VERSION}/${BUILD_INFO_FILENAME}"
  231. popd > /dev/null #${OUTPUT_DIR}
  232. # Update symlinks
  233. progress "Update symlink for ${BRANCH}"
  234. pushd ${OUTPUT_DIR} > /dev/null
  235. ln -fsn ${VERSION} ${BRANCH}
  236. popd > /dev/null #${OUTPUT_DIR}
  237. fi
  238. # The end. Finally.
  239. success "We're done, go and enjoy your new firmware (${VERSION})!"
  240. popd > /dev/null #${MY_DIR}